_qrtool() {
    local i cur prev opts cmd
    COMPREPLY=()
    cur="${COMP_WORDS[COMP_CWORD]}"
    prev="${COMP_WORDS[COMP_CWORD-1]}"
    cmd=""
    opts=""

    for i in ${COMP_WORDS[@]}
    do
        case "${cmd},${i}" in
            ",$1")
                cmd="qrtool"
                ;;
            qrtool,d)
                cmd="qrtool__decode"
                ;;
            qrtool,dec)
                cmd="qrtool__decode"
                ;;
            qrtool,decode)
                cmd="qrtool__decode"
                ;;
            qrtool,e)
                cmd="qrtool__encode"
                ;;
            qrtool,enc)
                cmd="qrtool__encode"
                ;;
            qrtool,encode)
                cmd="qrtool__encode"
                ;;
            qrtool,help)
                cmd="qrtool__help"
                ;;
            qrtool__help,decode)
                cmd="qrtool__help__decode"
                ;;
            qrtool__help,encode)
                cmd="qrtool__help__encode"
                ;;
            qrtool__help,help)
                cmd="qrtool__help__help"
                ;;
            *)
                ;;
        esac
    done

    case "${cmd}" in
        qrtool)
            opts="-h -V --generate-completion --help --version encode enc e decode dec d help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 1 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --generate-completion)
                    COMPREPLY=($(compgen -W "bash elvish fish nushell powershell zsh" -- "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        qrtool__decode)
            opts="-t -h -V --type --verbose --metadata --help --version [IMAGE]"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --type)
                    COMPREPLY=($(compgen -W "bmp dds farbfeld gif hdr ico jpeg openexr png pnm qoi svg tga tiff webp xbm" -- "${cur}"))
                    return 0
                    ;;
                -t)
                    COMPREPLY=($(compgen -W "bmp dds farbfeld gif hdr ico jpeg openexr png pnm qoi svg tga tiff webp xbm" -- "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        qrtool__decode)
            opts="-t -h -V --type --verbose --metadata --help --version [IMAGE]"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --type)
                    COMPREPLY=($(compgen -W "bmp dds farbfeld gif hdr ico jpeg openexr png pnm qoi svg tga tiff webp xbm" -- "${cur}"))
                    return 0
                    ;;
                -t)
                    COMPREPLY=($(compgen -W "bmp dds farbfeld gif hdr ico jpeg openexr png pnm qoi svg tga tiff webp xbm" -- "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        qrtool__decode)
            opts="-t -h -V --type --verbose --metadata --help --version [IMAGE]"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --type)
                    COMPREPLY=($(compgen -W "bmp dds farbfeld gif hdr ico jpeg openexr png pnm qoi svg tga tiff webp xbm" -- "${cur}"))
                    return 0
                    ;;
                -t)
                    COMPREPLY=($(compgen -W "bmp dds farbfeld gif hdr ico jpeg openexr png pnm qoi svg tga tiff webp xbm" -- "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        qrtool__encode)
            opts="-o -r -s -l -v -m -t -h -V --output --read-from --size --level --error-correction-level --symversion --symbol-version --margin --type --optimize-png --zopfli --mode --variant --foreground --background --verbose --help --version [STRING]"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --output)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -o)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --read-from)
                    local oldifs
                    if [ -n "${IFS+x}" ]; then
                        oldifs="$IFS"
                    fi
                    IFS=$'\n'
                    COMPREPLY=($(compgen -f "${cur}"))
                    if [ -n "${oldifs+x}" ]; then
                        IFS="$oldifs"
                    fi
                    if [[ "${BASH_VERSINFO[0]}" -ge 4 ]]; then
                        compopt -o filenames
                    fi
                    return 0
                    ;;
                -r)
                    local oldifs
                    if [ -n "${IFS+x}" ]; then
                        oldifs="$IFS"
                    fi
                    IFS=$'\n'
                    COMPREPLY=($(compgen -f "${cur}"))
                    if [ -n "${oldifs+x}" ]; then
                        IFS="$oldifs"
                    fi
                    if [[ "${BASH_VERSINFO[0]}" -ge 4 ]]; then
                        compopt -o filenames
                    fi
                    return 0
                    ;;
                --size)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -s)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --error-correction-level)
                    COMPREPLY=($(compgen -W "l m q h" -- "${cur}"))
                    return 0
                    ;;
                --level)
                    COMPREPLY=($(compgen -W "l m q h" -- "${cur}"))
                    return 0
                    ;;
                -l)
                    COMPREPLY=($(compgen -W "l m q h" -- "${cur}"))
                    return 0
                    ;;
                --symbol-version)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --symversion)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -v)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --margin)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -m)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --type)
                    COMPREPLY=($(compgen -W "png svg pic ansi ansi256 ansi-true-color ascii ascii-invert unicode unicode-invert" -- "${cur}"))
                    return 0
                    ;;
                -t)
                    COMPREPLY=($(compgen -W "png svg pic ansi ansi256 ansi-true-color ascii ascii-invert unicode unicode-invert" -- "${cur}"))
                    return 0
                    ;;
                --optimize-png)
                    COMPREPLY=($(compgen -W "0 1 2 3 4 5 6" -- "${cur}"))
                    return 0
                    ;;
                --zopfli)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --mode)
                    COMPREPLY=($(compgen -W "numeric alphanumeric byte kanji" -- "${cur}"))
                    return 0
                    ;;
                --variant)
                    COMPREPLY=($(compgen -W "normal micro" -- "${cur}"))
                    return 0
                    ;;
                --foreground)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --background)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        qrtool__encode)
            opts="-o -r -s -l -v -m -t -h -V --output --read-from --size --level --error-correction-level --symversion --symbol-version --margin --type --optimize-png --zopfli --mode --variant --foreground --background --verbose --help --version [STRING]"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --output)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -o)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --read-from)
                    local oldifs
                    if [ -n "${IFS+x}" ]; then
                        oldifs="$IFS"
                    fi
                    IFS=$'\n'
                    COMPREPLY=($(compgen -f "${cur}"))
                    if [ -n "${oldifs+x}" ]; then
                        IFS="$oldifs"
                    fi
                    if [[ "${BASH_VERSINFO[0]}" -ge 4 ]]; then
                        compopt -o filenames
                    fi
                    return 0
                    ;;
                -r)
                    local oldifs
                    if [ -n "${IFS+x}" ]; then
                        oldifs="$IFS"
                    fi
                    IFS=$'\n'
                    COMPREPLY=($(compgen -f "${cur}"))
                    if [ -n "${oldifs+x}" ]; then
                        IFS="$oldifs"
                    fi
                    if [[ "${BASH_VERSINFO[0]}" -ge 4 ]]; then
                        compopt -o filenames
                    fi
                    return 0
                    ;;
                --size)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -s)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --error-correction-level)
                    COMPREPLY=($(compgen -W "l m q h" -- "${cur}"))
                    return 0
                    ;;
                --level)
                    COMPREPLY=($(compgen -W "l m q h" -- "${cur}"))
                    return 0
                    ;;
                -l)
                    COMPREPLY=($(compgen -W "l m q h" -- "${cur}"))
                    return 0
                    ;;
                --symbol-version)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --symversion)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -v)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --margin)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -m)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --type)
                    COMPREPLY=($(compgen -W "png svg pic ansi ansi256 ansi-true-color ascii ascii-invert unicode unicode-invert" -- "${cur}"))
                    return 0
                    ;;
                -t)
                    COMPREPLY=($(compgen -W "png svg pic ansi ansi256 ansi-true-color ascii ascii-invert unicode unicode-invert" -- "${cur}"))
                    return 0
                    ;;
                --optimize-png)
                    COMPREPLY=($(compgen -W "0 1 2 3 4 5 6" -- "${cur}"))
                    return 0
                    ;;
                --zopfli)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --mode)
                    COMPREPLY=($(compgen -W "numeric alphanumeric byte kanji" -- "${cur}"))
                    return 0
                    ;;
                --variant)
                    COMPREPLY=($(compgen -W "normal micro" -- "${cur}"))
                    return 0
                    ;;
                --foreground)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --background)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        qrtool__encode)
            opts="-o -r -s -l -v -m -t -h -V --output --read-from --size --level --error-correction-level --symversion --symbol-version --margin --type --optimize-png --zopfli --mode --variant --foreground --background --verbose --help --version [STRING]"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --output)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -o)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --read-from)
                    local oldifs
                    if [ -n "${IFS+x}" ]; then
                        oldifs="$IFS"
                    fi
                    IFS=$'\n'
                    COMPREPLY=($(compgen -f "${cur}"))
                    if [ -n "${oldifs+x}" ]; then
                        IFS="$oldifs"
                    fi
                    if [[ "${BASH_VERSINFO[0]}" -ge 4 ]]; then
                        compopt -o filenames
                    fi
                    return 0
                    ;;
                -r)
                    local oldifs
                    if [ -n "${IFS+x}" ]; then
                        oldifs="$IFS"
                    fi
                    IFS=$'\n'
                    COMPREPLY=($(compgen -f "${cur}"))
                    if [ -n "${oldifs+x}" ]; then
                        IFS="$oldifs"
                    fi
                    if [[ "${BASH_VERSINFO[0]}" -ge 4 ]]; then
                        compopt -o filenames
                    fi
                    return 0
                    ;;
                --size)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -s)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --error-correction-level)
                    COMPREPLY=($(compgen -W "l m q h" -- "${cur}"))
                    return 0
                    ;;
                --level)
                    COMPREPLY=($(compgen -W "l m q h" -- "${cur}"))
                    return 0
                    ;;
                -l)
                    COMPREPLY=($(compgen -W "l m q h" -- "${cur}"))
                    return 0
                    ;;
                --symbol-version)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --symversion)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -v)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --margin)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -m)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --type)
                    COMPREPLY=($(compgen -W "png svg pic ansi ansi256 ansi-true-color ascii ascii-invert unicode unicode-invert" -- "${cur}"))
                    return 0
                    ;;
                -t)
                    COMPREPLY=($(compgen -W "png svg pic ansi ansi256 ansi-true-color ascii ascii-invert unicode unicode-invert" -- "${cur}"))
                    return 0
                    ;;
                --optimize-png)
                    COMPREPLY=($(compgen -W "0 1 2 3 4 5 6" -- "${cur}"))
                    return 0
                    ;;
                --zopfli)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --mode)
                    COMPREPLY=($(compgen -W "numeric alphanumeric byte kanji" -- "${cur}"))
                    return 0
                    ;;
                --variant)
                    COMPREPLY=($(compgen -W "normal micro" -- "${cur}"))
                    return 0
                    ;;
                --foreground)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --background)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        qrtool__help)
            opts="encode decode help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        qrtool__help__decode)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        qrtool__help__encode)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        qrtool__help__help)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
    esac
}

if [[ "${BASH_VERSINFO[0]}" -eq 4 && "${BASH_VERSINFO[1]}" -ge 4 || "${BASH_VERSINFO[0]}" -gt 4 ]]; then
    complete -F _qrtool -o nosort -o bashdefault -o default qrtool
else
    complete -F _qrtool -o bashdefault -o default qrtool
fi
